<template>
  <div>
    <!-- {{ editablePath }} -->
    <!-- <input v-model="fieldData" :disabled="config.read_only" :style="{ backgroundColor: isFieldEdited({ node, path }) ? '#c3dfff' : '' }"> -->
    <inline-editor :id="path.join('.')" v-model="textareaRawData" :read-only="config.read_only" :placeholder="textareaPlaceholder" :class="{ 'read-only': config.read_only }" type="multi" :style="{ backgroundColor: isFieldEdited({ node, path }) ? '#c3dfff' : '' }"></inline-editor>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

// import Ckeditor from '@/components/Editable/Fields/CKEditor'
import InlineEditor from '@/components/Editable/Utils/InlineEditor'

export default {
  components: {
    InlineEditor
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    },
    // config: {
    //   type: Object,
    //   required: true
    // },
    defaults: {
      required: false
    }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      isFieldEdited: 'Y3TI/isFieldEdited',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    textareaPlaceholder () {
      return _.get(this.config, 'widget.form.settings.placeholder')
    },

    textareaRawData: {
      get () {
        // return _.get(this.$store.state.app.edited, this.editablePath)
        const data = this.getEditedField({ node: this.node, path: this.path })
        return data === null ? _.get(this.defaults) : data
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
      }
    }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...[this.config.path] ]
    // }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
  }
}
</script>

<style lang="scss" scoped>
  .read-only {
    border: gray solid;
    background-color: gray;
    color: white;
  }
</style>
